#
# make cscope for win32 console
#
# We use the Microsoft Visual C++ compiler to produce an executable
# that works with long file names and can use / instead of \ between
# path elements.
#

# set the name of the executable
PROGRAM=cscope

# turn options on / off
SVR2=U
BSD=U
BSD42=U
AIX=U
VOID_PROTOTYPE=D

# how to compile / link
CC_HOME	="C:\Program Files\Microsoft Visual Studio\VC98"
STDINC	=$(CC_HOME)\Include
MODEL	=L        # one of L, S, M, T, H, C
SIZE	=LARGE    # one of LARGE, SMALL, MEDIUM, TINY, HUGE, COMPACT
CC=cl
CCDEBUG=-Ox
#CCDEBUG=-Zi
#CFLAGS  =-nologo $(CCDEBUG) -A$(MODEL) -FPi87 -G2 -Lp -Za -Gt50 \
CFLAGS	=-nologo $(CCDEBUG) -DMSVC \
	-D$(SIZE) -DFOR_WIN32 -DINTSIZE=16 -DPTRSIZE=32 -$(SVR2)SVR2 \
	-$(BSD)BSD -$(BSD42)BSD42 -$(VOID_PROTOTYPE)VOID_PROTOTYPE -$(AIX)AIX \
	-DUSING_PD_CURSES -I../win32/curses -I ../win32/pdcurses_2.4 -I$(STDINC)
LDDBG=
#LDDBG=/CO
#LDFLAGS =/nologo $(LDDBG) /NOE /SE:300 /ST:0xB000 /NOD /PMTYPE:VIO
LDFLAGS	= -nologo -libpath:$(CC_HOME)\Lib 
LINK	=link
LIBEXE  =lib
#CCLIBS	=$(CC_HOME)\LIB\$(MODEL)LIBC7P.LIB+$(CC_HOME)\LIB\os2.lib
CCLIBS	= user32.lib kernel32.lib
LIBCURSES =..\win32\curses\pdcurses.lib

# extensions
O=.obj
E=.exe

all: $(PROGRAM)$(E)

clean:
	-del *$(O)
	-del *.lib
	-del *.map
	-del *.bak
	-del egrep.c

clobber: clean
	-del $(PROGRAM)$(E)

# what objects to build into a library
LEX_YACC_OBJ=reject$(O) yyless$(O) yywrap$(O)
OBJECTS=alloc$(O) basename$(O) command$(O) compath$(O) crossref$(O) dir$(O) \
    dirent$(O) display$(O) edit$(O) egrep$(O) exec$(O) find$(O) getwd$(O) \
    help$(O) history$(O) input$(O) invlib$(O) logdir$(O) lookup$(O) menu$(O) \
    mouse$(O) mygetenv$(O) mygetwd$(O) regcmp$(O) regex$(O) scanner$(O) \
    sleep$(O) vpaccess$(O) vpfopen$(O) vpinit$(O) vpopen$(O) vpstat$(O) \
    $(LEX_YACC_OBJ)

# how to create the library
cscope.lib: $(OBJECTS)
	$(LIBEXE) -nologo -out:cscope.lib $(OBJECTS)
#	$(LIBEXE) cscope.lib /nologo @<<
#-+alloc.obj&
#-+basename.obj&
#-+command.obj&
#-+compath.obj&
#-+crossref.obj&
#-+dir.obj&
#-+dirent.obj&
#-+display.obj&
#-+edit.obj&
#-+egrep.obj&
#-+exec.obj&
#-+find.obj&
#-+getwd.obj&
#-+help.obj&
#-+history.obj&
#-+input.obj&
#-+invlib.obj&
#-+logdir.obj&
#-+lookup.obj&
#-+menu.obj&
#-+mouse.obj&
#-+mygetenv.obj&
#-+mygetwd.obj&
#-+regcmp.obj&
#-+regex.obj&
#-+reject.obj&
#-+scanner.obj&
#-+sleep.obj&
#-+vpaccess.obj&
#-+vpfopen.obj&
#-+vpinit.obj&
#-+vpopen.obj&
#-+vpstat.obj&
#-+yyless.obj&
#-+yywrap.obj;
#<<

# how to link the program
$(PROGRAM)$(E): main$(O) cscope.lib
	$(LINK) $(LDFLAGS) -out:$@ main$(O) cscope.lib $(LIBCURSES) $(CCLIBS)
#	$(LINK) $(LDFLAGS) main$(O),$@,$*.map,cscope.lib+$(LIBCURSES)+$(CCLIBS);

# how to compile the stuff in the win32 directory
sleep.obj: win32/sleep.c
	$(CC) -c $(CFLAGS) -Ze -Iwin32 win32/sleep.c -Fosleep.obj

dirent.obj: win32/dirent.c
	$(CC) -c $(CFLAGS) -Ze -Iwin32 win32/dirent.c -Fodirent.obj

#
# how to create egrep.c
#
# If you have yacc or bison, then by all means use it.  But, the rest of us
# will just copy the pre-processed egrep.y.out to egrep.c!
#
egrep.c: egrep.y.out
	-del egrep.c
	copy egrep.y.out egrep.c
